// Copyright 2022 The TensorStore Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef TENSORSTORE_KVSTORE_OCDBT_TEST_UTIL_H_
#define TENSORSTORE_KVSTORE_OCDBT_TEST_UTIL_H_

#include <memory>

#include "tensorstore/kvstore/ocdbt/driver.h"
#include "tensorstore/kvstore/ocdbt/format/manifest.h"
#include "tensorstore/util/result.h"

namespace tensorstore {
namespace internal_ocdbt {

IoHandle::Ptr GetOcdbtIoHandle(kvstore::Driver& driver);

Result<std::shared_ptr<const Manifest>> ReadManifest(OcdbtDriver& driver);

// Tests that if a batch of writes leaves a node unmodified, it is not
// rewritten.
void TestUnmodifiedNode(const Context& context = {});

}  // namespace internal_ocdbt
}  // namespace tensorstore

#endif  // TENSORSTORE_KVSTORE_OCDBT_TEST_UTIL_H_
